/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: config2.h,v 1.34 2003/06/13 15:01:07 erik Rel $
 ********************************************************************************************************************************/

#ifndef _XZX_CONFIG2_H
#define _XZX_CONFIG2_H

/*********************************************************************************************************************************
 * Do not change anything below this line
 ********************************************************************************************************************************/

#define USED(x)							(void)(x)

#if SIZEOF_CHAR != 1
#error "sizeof(char) is not equal to 8 bit"
#endif

#if SIZEOF_SHORT != 2
#error "sizeof(short) is not equal to 16 bit"
#endif

#if SIZEOF_INT != 4
#error "sizeof(int) is not equal to 32 bit"
#endif

#define EXTERN_Z80_TYPEDEFS
typedef unsigned char					uns8;
typedef unsigned short					uns16;
typedef unsigned int					uns32;
typedef signed char						sgn8;
typedef signed short					sgn16;
typedef signed int						sgn32;

#undef DEBUG_HALT
#undef DEBUG_R_REGISTER
#undef DEBUG_EVENTS
#undef BROCKEN_VISUAL_SUPPORT
#define SPEEDUP_TRDOS
#define VIRTUAL_DISK_IMAGES
#undef REAL_DISKS
#undef SOUND_NONBLOCKING

#if IF1_DRIVES > 8 || IF1_DRIVES < 1
#define IF1_DRIVES						2
#endif

#if defined(PLUS3_PRINTER) || defined(SCORPION_PRINTER) || defined(PLUSD_PRINTER)
#define CENTRONICS_PRINTER
#endif

#if defined(ZX_PRINTER) || defined(IF1_PRINTER) || defined(SP128_PRINTER) || defined(CENTRONICS_PRINTER)
#define PRINTER
#endif

#ifdef XZX_IF1
#define RS232
#endif

#if defined(XZX_PENTAGON) && defined(XZX_SCORPION)
#define PENTAGON_OR_SCORPION 			(CFGGET(machine) == SP_PENTAGON || CFGGET(machine) == SP_SCORPION)
#elif defined(XZX_PENTAGON)
#define PENTAGON_OR_SCORPION 			(CFGGET(machine) == SP_PENTAGON)
#elif defined(XZX_SCORPION)
#define PENTAGON_OR_SCORPION 			(CFGGET(machine) == SP_SCORPION)
#else
#define PENTAGON_OR_SCORPION 			0
#endif

#if (defined(XZX_PENTAGON) || defined(XZX_SCORPION)) && !defined(EVALUATION)
#ifndef XZX_TRDOS
#define XZX_TRDOS
#endif
#endif

#ifdef XZX_TRDOS
#define DISK_DRIVES						4
#else
#define DISK_DRIVES						2
#undef VIRTUAL_DISK_IMAGES
#endif

#if !defined(XZX_PENTAGON) && !defined(XZX_SCORPION) && defined(XZX_KMOUSE)
#undef XZX_KMOUSE
#endif

#ifdef EVALUATION
#undef XZX_DIDAKTIK
#undef XZX_TRDOS
#undef XZX_PLUSD
#undef ZX_PRINTER
#undef IF1_PRINTER
#undef SP128_PRINTER
#undef PLUS3_PRINTER
#undef SCORPION_PRINTER
#undef PLUSD_PRINTER
#undef CENTRONICS_PRINTER
#undef PRINTER
#undef RS232
#endif

#endif /* ! _XZX_CONFIG2_H */

/* EOF **************************************************************************************************************************/
