/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: ddrive.c,v 1.13 2003/03/17 18:41:28 erik Rel $";
#endif
#include <stdlib.h>
#include <assert.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "disk.h"
#include "ui/sbar.h"
#include "ddrive.h"
#define DDRIVE_LED_ON()	SbarSetLed(LED_ON)
#define DDRIVE_LED_OFF()	SbarSetLed(LED_OFF)
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_FDC) != 0) { x } }
#else
#define DEB(x)
#endif
Ddrive*DdriveNew(DdriveType type){Ddrive*ddp=Malloc(sizeof(Ddrive),"DdriveNew");ddp->type=type;ddp->sides=type==DDRIVE_SDSS||type==DDRIVE_DDSS?1:2;ddp->tracks=type==DDRIVE_SDSS||type==DDRIVE_SDDS?40:80;return ddp;}int DdriveInsertDisk(Ddrive*ddp,const char*fname){if(ddp->disk!=(Disk*)0){DdriveEjectDisk(ddp);}if((ddp->disk=DiskOpen(fname))==(Disk*)0){return-1;}return 0;}void DdriveEjectDisk(Ddrive*ddp){DiskClose(ddp->disk);ddp->disk=(Disk*)0;}void DdriveMotor(Ddrive*ddp,unsigned int state){if(state!=ddp->motor){DEB(Msg(M_DEBUG,"DD: drive %d motor %s",ddp->id,state==0?"off":"on"););if(state==0){DDRIVE_LED_OFF();}else{}ddp->motor=state;}}int DdriveSeek(Ddrive*ddp,int seek){assert(seek!=0);DEB(Msg(M_DEBUG,"DD: track %d seek %d",ddp->currentTrack,seek););DDRIVE_LED_ON();ddp->currentTrack+=seek;if(ddp->currentTrack>=ddp->tracks){ddp->currentTrack=ddp->tracks-1;return-1;}else if(ddp->currentTrack<0){ddp->currentTrack=0;return-1;}return 0;}DiskSectorInfo*DdriveNextId(Ddrive*ddp){Disk*dp=ddp->disk;unsigned int numSectors=dp->tracks[ddp->currentSide][ddp->currentTrack].numSectors;if(numSectors==0){DEB(Msg(M_DEBUG,"DD: track %d not formatted",ddp->currentTrack););numSectors=9;}DDRIVE_LED_ON();if((unsigned int)(++ddp->currentSector)>=numSectors){ddp->currentSector=0;}return(dp->getSectorInfo(dp,(unsigned int)(ddp->currentSide),(unsigned int)(ddp->currentTrack),(unsigned int)(ddp->currentSector)));}uns8*DdriveReadSector(Ddrive*ddp){DDRIVE_LED_ON();return ddp->disk->tracks[ddp->currentSide][ddp->currentTrack].sectors[ddp->currentSector].data;}uns8*DdriveWriteSector(Ddrive*ddp){DDRIVE_LED_ON();return ddp->disk->tracks[ddp->currentSide][ddp->currentTrack].sectors[ddp->currentSector].data;}int DdriveIsReady(Ddrive*ddp){if(!DdriveIsLoaded(ddp)&&CFGGET(smartAttach)!=0){assert(ddp->insert!=(int(*)(int))0);ddp->insert(ddp->id);}return(ddp->motor!=0&&DdriveIsLoaded(ddp));}
