/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_DDRIVE_H
#define _XZX_DDRIVE_H
#include "disk.h"
typedef enum{DDRIVE_SDSS,DDRIVE_DDSS,DDRIVE_SDDS,DDRIVE_DDDS}DdriveType;typedef struct _ddrive{DdriveType type;int id;int sides;int tracks;int currentSide;int currentTrack;int currentSector;unsigned int motor:1;Disk*disk;int(*insert)(int);}Ddrive;
#define DdriveIsDS(ddp)	((ddp)->sides == 2)
#define DdriveIsAtTrack0(ddp)	((ddp)->currentTrack == 0)
#define DdriveIsLoaded(ddp)	((ddp)->disk != (Disk *)0)
#define DdriveIsWriteProtected(ddp)	((ddp)->disk->readonly != 0)
#define DdriveIsIndexHole(ddp)	((ddp)->currentSector == 0)
#define DdriveGetTrack(ddp)	((ddp)->currentTrack)
#define DdriveGetSide(ddp)	((ddp)->currentSide)
#define DdriveSetSide(ddp,head)	(ddp)->currentSide = (head)
#define DdriveSetIF(ddp,func)	(ddp)->insert = (func)
extern Ddrive*DdriveNew(DdriveType);extern int DdriveInsertDisk(Ddrive*,const char*);extern void DdriveEjectDisk(Ddrive*);extern void DdriveMotor(Ddrive*,unsigned int);extern int DdriveSeek(Ddrive*,int);extern DiskSectorInfo*DdriveNextId(Ddrive*);extern uns8*DdriveReadSector(Ddrive*);extern uns8*DdriveWriteSector(Ddrive*);extern int DdriveIsReady(Ddrive*);
#endif 

