/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: disk.c,v 1.13 2003/03/14 21:40:31 erik Rel $";
#endif
#include <stdlib.h>
#include <assert.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "fileio/dsk.h"
#ifdef XZX_TRDOS
#include "fileio/trd.h"
#include "fileio/fdi.h"
#include "fileio/scl.h"
#ifdef VIRTUAL_DISK_IMAGES
#include "fileio/hobeta.h"
#endif
#endif
#ifdef XZX_PLUSD
#include "fileio/mgt.h"
#include "fileio/img.h"
#endif
#ifdef XZX_DIDAKTIK
#include "fileio/d80.h"
#endif
#include "disk.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_DISK) != 0) { x } }
#else
#define DEB(x)
#endif
Disk*DiskOpen(const char*fname){Disk*dp=(Disk*)0;switch(GetFileType(fname)){case FILE_TYPE_DSK:dp=DskOpen(fname);break;
#ifdef XZX_TRDOS
case FILE_TYPE_TRD:dp=TrdOpen(fname);break;case FILE_TYPE_FDI:dp=FdiOpen(fname);break;case FILE_TYPE_SCL:dp=SclOpen(fname);break;
#ifdef VIRTUAL_DISK_IMAGES
case FILE_TYPE_HOB:dp=HobetaOpen(fname);break;
#endif
#endif
#ifdef XZX_PLUSD
case FILE_TYPE_MGT:dp=MgtOpen(fname);break;case FILE_TYPE_IMG:dp=ImgOpen(fname);break;
#endif
#ifdef XZX_DIDAKTIK
case FILE_TYPE_D80:dp=D80Open(fname);break;
#endif
default:assert(0);break;}DEB(if(dp!=(Disk*)0){Msg(M_DEBUG,"DISK: %d sides, %d tracks, %d sectors, %d bytes, read%s",dp->numSides,dp->numTracks,dp->tracks[0][0].numSectors,dp->tracks[0][0].sectors[0].size,dp->readonly?"only":"write");});return dp;}void DiskClose(Disk*dp){assert(dp!=(Disk*)0);Munmap(dp->mmp,dp->mmsize);free((void*)dp->fname);free(dp);}
