/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_DISK_H
#define _XZX_DISK_H
#include <sys/types.h>
#define MAX_DISK_SECTORS	18
#define MAX_DISK_TRACKS	82
#define MAX_DISK_SIDES	2
typedef struct _sectorInfo{uns8 track;uns8 head;uns8 sector;uns8 bps;uns8 crc1;uns8 crc2;}DiskSectorInfo;typedef struct _sector{unsigned int size;uns8*info;uns8*data;}DiskSector;typedef struct _track{unsigned int numSectors;DiskSector sectors[MAX_DISK_SECTORS];}DiskTrack;typedef struct _disk{const char*fname;int readonly;uns8*mmp;size_t mmsize;unsigned int numSides;unsigned int numTracks;DiskTrack tracks[MAX_DISK_SIDES][MAX_DISK_TRACKS];DiskSectorInfo*(*getSectorInfo)(struct _disk*,unsigned int,unsigned int,unsigned int);}Disk;
#define DiskGetSectorInfo(dp,h,t,s)	dp->getSectorInfo(dp,h,t,s)
extern Disk*DiskOpen(const char*);extern void DiskClose(Disk*);
#endif 

