/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef XZX_KMOUSE
#ifndef lint
static char rcsid[]="$Id: kmouse.c,v 1.23 2003/03/27 01:04:35 erik Rel $";
#endif
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <stdio.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "ui/xwin.h"
#include "machine/kmouse.h"
#define L_BUTTON	0x02
#define M_BUTTON	0x04
#define R_BUTTON	0x01
#define ZONE_OFFSET	(signed int)BORDER_PIXELS
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_X11) != 0) { x } }
#else
#define DEB(x)
#endif
static void kmouseMove(Widget,XtPointer,XEvent*,Boolean*);static void kmouseButton(Widget,XtPointer,XEvent*,Boolean*);static void kmouseEnter(Widget,XtPointer,XEvent*,Boolean*);uns8 KmouseX,KmouseY,KmouseButtons;static Cursor blankCursor;static int x,y;void KmouseInit(void){char bm;Pixmap pm;XColor c;bm=0;pm=XCreatePixmapFromBitmapData(XwinDataP->display,XtWindow(XwinDataP->emuWindow),&bm,1,1,0,0,1);blankCursor=XCreatePixmapCursor(XwinDataP->display,pm,pm,&c,&c,0,0);if(CFGGET(kmouse)!=0){KmouseOn();}}void KmouseOn(void){Widget emuWindow=XwinDataP->emuWindow;XtAddEventHandler(emuWindow,PointerMotionMask,False,kmouseMove,XtNull);XtAddEventHandler(emuWindow,ButtonPressMask|ButtonReleaseMask,False,kmouseButton,XtNull);XtAddEventHandler(emuWindow,EnterWindowMask,False,kmouseEnter,XtNull);XDefineCursor(XtDisplay(emuWindow),XtWindow(emuWindow),blankCursor);if(CFGGET(kmouseGrab)!=0){(void)XtGrabPointer(emuWindow,True,PointerMotionMask,GrabModeAsync,GrabModeAsync,XtWindow(emuWindow),(Cursor)0,CurrentTime);XWarpPointer(XtDisplay(emuWindow),XtWindow(emuWindow),XtWindow(emuWindow),0,0,0U,0U,0,0);XSync(XtDisplay(emuWindow),False);}KmouseX=x=0;KmouseY=y=0;KmouseButtons=0xff;}void KmouseOff(void){Widget emuWindow=XwinDataP->emuWindow;XtRemoveEventHandler(emuWindow,PointerMotionMask,0,kmouseMove,XtNull);XtRemoveEventHandler(emuWindow,ButtonPressMask|ButtonReleaseMask,0,kmouseButton,XtNull);XtRemoveEventHandler(emuWindow,EnterWindowMask,0,kmouseEnter,XtNull);(void)XUndefineCursor(XtDisplay(emuWindow),XtWindow(emuWindow));XtUngrabPointer(emuWindow,CurrentTime);}static void kmouseMove(Widget w,XtPointer client,XEvent*xev,Boolean*cont){USED(w);USED(client);USED(cont);DEB(Msg(M_DEBUG,"KMOUSE: x %d, y %d",xev->xmotion.x,xev->xmotion.y););if(x!=xev->xmotion.x||y!=xev->xmotion.y){KmouseX-=(x-xev->xmotion.x)/CFGGET(scale);KmouseY+=(y-xev->xmotion.y)/CFGGET(scale);if(CFGGET(kmouseGrab)!=0&&(x<ZONE_OFFSET||y<ZONE_OFFSET||x>((int)(XwinDataP->hsize)-ZONE_OFFSET)||y>((int)(XwinDataP->vsize)-ZONE_OFFSET))){x=XwinDataP->hsize>>1;y=XwinDataP->vsize>>1;(void)XWarpPointer(XtDisplay(w),XtWindow(w),XtWindow(w),0,0,0U,0U,x,y);}else{x=xev->xmotion.x;y=xev->xmotion.y;}}}static void kmouseButton(Widget w,XtPointer client,XEvent*xev,Boolean*cont){uns8 mask;USED(w);USED(client);USED(cont);switch(xev->xbutton.button){case Button1:mask=L_BUTTON;break;case Button2:mask=M_BUTTON;break;case Button3:mask=R_BUTTON;break;default:mask=0xff;break;}DEB(Msg(M_DEBUG,"KMOUSE: %s %x",xev->type==ButtonPress?"press":"release",mask););if(xev->type==ButtonPress){KmouseButtons&=~mask;}else{KmouseButtons|=mask;}}static void kmouseEnter(Widget w,XtPointer client,XEvent*xev,Boolean*cont){USED(client);USED(xev);USED(cont);if(CFGGET(kmouseGrab)!=0){(void)XtGrabPointer(w,True,PointerMotionMask,GrabModeAsync,GrabModeAsync,XtWindow(w),(Cursor)0,CurrentTime);(void)XSync(XtDisplay(w),False);}}
#endif 

