/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_MACHINE_MEM_H
#define _XZX_MACHINE_MEM_H
#define XZX_PAGESIZE	16384	
enum{SP48ROM,SP128ROM0,SP128ROM1,SP3ROM0,SP3ROM1,SP3ROM2,SP3ROM3,
#ifdef XZX_PENTAGON
PENTROM0,PENTROM1,PENTROM2,
#endif
#ifdef XZX_SCORPION
SCORROM0,SCORROM1,SCORROM2,SCORROM3,
#endif
#ifdef XZX_DIDAKTIK
DIDROM,D80ROM,
#endif
#ifdef XZX_IF1
IF1ROM,
#endif
#ifdef XZX_MF
MF1ROM,MF128ROM,MF3ROM,
#endif
#ifdef XZX_TRDOS
TRDOSROM,
#endif
#ifdef XZX_PLUSD
PLUSDROM,
#endif
RAM0,RAM1,RAM2,RAM3,RAM4,RAM5,RAM6,RAM7,
#ifdef XZX_SCORPION
RAM8,RAM9,RAMA,RAMB,RAMC,RAMD,RAME,RAMF,
#endif
NPAGES};
#define MFRAM	RAM0
#define PLUSDRAM	RAM0
#define VPAGE(addr)	((addr) >> 13)
#define RPAGE(addr)	(RealPageNumbers[VPAGE(addr)])
#define MEM(addr)	(TheMemory[VPAGE(addr)][(addr) & 0x1fff])
#define READ_ONLY(addr)	(RPAGE(addr) < RAM0)
extern void MemoryInit(void);extern int LoadRomImage(const char*,int,int);extern int GetRomChecksum(int,int);extern uns8*TheMemory[8];extern int RealPageNumbers[8];extern uns8*RealMemory[NPAGES];
#endif 

