/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_arts.c,v 4.9 2003/05/02 20:19:12 erik Rel $";
#endif
#include <sys/types.h>
#include <errno.h>
#include <assert.h>
#include <artsc.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "main.h"
#include "sound/sound.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static arts_stream_t audioStream=(arts_stream_t)0;int OsdOpenAudioDevice(const char*device,int*sample,int*stereo){int i;USED(device);if((i=arts_init())<0){Msg(M_ERR,"couldn't connect to audio server\n  -> reason: %s",arts_error_text(i));return(i==ARTS_E_NOSERVER?-2:-1);}if((audioStream=arts_play_stream(*sample,8,2,Version))==(arts_stream_t)0){Msg(M_ERR,"couldn't open stream\n  -> reason: %s",arts_error_text(i));goto error;}*stereo=1;
#ifdef SOUND_NONBLOCKING
i=0;
#else
i=1;
#endif
if((i=arts_stream_set(audioStream,ARTS_P_BLOCKING,i))<0){Msg(M_ERR,"couldn't configure stream\n  -> reason: %s",arts_error_text(i));goto error;}return 0;error:if(audioStream!=(arts_stream_t)0){arts_close_stream(audioStream);audioStream=(arts_stream_t)0;}arts_free();return-1;}void OsdCloseAudioDevice(void){assert(audioStream!=(arts_stream_t)0);arts_close_stream(audioStream);audioStream=(arts_stream_t)0;arts_free();}int OsdDrainAudioDevice(void){return 0;}
#ifdef SOUND_NONBLOCKING
int OsdGetAudioFreespace(void){return(arts_stream_get(audioStream,ARTS_P_BUFFER_SPACE));}
#endif
int OsdPlayAudioBuffer(unsigned char*buf,int len){int written;written=arts_write(audioStream,buf,len);if(written<0){Msg(M_ERR,"couldn't write to audio device\n  -> reason: %s",arts_error_text(written));}return written;}
