/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2003
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_irix.c,v 4.4 2003/03/26 18:35:06 erik Rel $";
#endif
#include <sys/types.h>
#include <assert.h>
#include <dmedia/audio.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "main.h"
#include "sound/sound.h"
#ifdef HAVE_al_FUNCS
#define ALopenport	alOpenPort
#define ALcloseport	alClosePort
#define ALfreeconfig	alFreeConfig
#define ALgetfillable	alGetFillable
#define ALwritesamps	alWriteFrames
#endif
static ALport audioPort=(ALport)0;int OsdOpenAudioDevice(const char*device,int*sample,int*stereo){ALconfig audioConfig;
#if HAVE_al_FUNCS
ALpv pvs[4];int alIsBusy=0;pvs[0].param=AL_MAX_PORTS;pvs[1].param=AL_UNUSED_PORTS;if(alGetParams(AL_SYSTEM,pvs,2)<0){return-1;}if(pvs[1].value.i<1){Msg(M_WARN,"audio device in use");return-1;}if(pvs[1].value.i<pvs[0].value.i){pvs[0].param=AL_RATE;if(alGetParams(AL_DEFAULT_OUTPUT,pvs,1)<0){return-1;}*sample=pvs[0].value.i;alIsBusy=1;}if((audioConfig=alNewConfig())==(ALconfig)0){return-1;}*stereo=1;if(alSetChannels(audioConfig,AL_STEREO)<0||alSetQueueSize(audioConfig,(long)(*sample<<*stereo))<0||alSetSampFmt(audioConfig,AL_SAMPFMT_TWOSCOMP)<0||alSetWidth(audioConfig,AL_SAMPLE_8)<0){Msg(M_ERR,"couldn't set channel-specific parameters");goto error;}pvs[0].param=AL_MASTER_CLOCK;pvs[0].value.i=AL_CRYSTAL_MCLK_TYPE;pvs[1].param=AL_RATE;pvs[1].value.i=*sample;if(alIsBusy==0){if(alSetParams(AL_DEFAULT_OUTPUT,pvs,2)<0){Msg(M_ERR,"couldn't set audio-device parameters");goto error;}}
#else
long param[4];param[0]=AL_INPUT_COUNT;param[2]=AL_OUTPUT_COUNT;(void)ALgetparams(AL_DEFAULT_DEVICE,param,4);if(param[1]||param[3]){Msg(M_WARN,"audio device in use");return-1;}if((audioConfig=ALnewconfig())==(ALconfig)0){return-1;}*stereo=1;if(ALsetchannels(audioConfig,AL_STEREO)<0||ALsetqueuesize(audioConfig,(long)(*sample<<*stereo))<0||ALsetsampfmt(audioConfig,AL_SAMPFMT_TWOSCOMP)<0||ALsetwidth(audioConfig,AL_SAMPLE_8)<0){Msg(M_ERR,"couldn't set channel-specific parameters");goto error;}param[0]=AL_OUTPUT_RATE;param[1]=(long)*sample;param[2]=AL_INPUT_RATE;param[3]=(long)*sample;if(ALsetparams(AL_DEFAULT_DEVICE,param,4)<0){Msg(M_ERR,"couldn't set audio-device parameters");goto error;}
#endif 
if((audioPort=ALopenport(Version,"w",audioConfig))==(ALport)0){Msg(M_ERR,"couldn't open audio device for writing");goto error;}(void)ALfreeconfig(audioConfig);return 0;error:if(audioPort!=(ALport)0){(void)ALcloseport(audioPort);audioPort=(ALport)0;}(void)ALfreeconfig(audioConfig);return-1;}void OsdCloseAudioDevice(void){assert(audioPort!=(ALport)0);(void)ALcloseport(audioPort);audioPort=(ALport)0;}int OsdDrainAudioDevice(void){return 0;}
#ifdef SOUND_NONBLOCKING
int OsdGetAudioFreespace(void){return(ALgetfillable(audioPort));}
#endif
int OsdPlayAudioBuffer(unsigned char*buf,int len){int written,i;for(i=0;i<len;i++){buf[i]^=0x80;}if((written=ALwritesamps(audioPort,buf,(long)len))<0){Msg(M_ERR,"couldn't write to audio device");return written;}return len;}
